<?php
/*
Plugin Name: Google Standout
Version: 0.5
Plugin URI: http://www.ktstudios.com/wordpress-plugin-google-standout
Description: Google News Publisher metadata tags plugin.
Author: KTStudios
Author URI: http://www.ktstudios.com/
*/

/*  Copyright 2011  KTStudios  (email : admin@ktstudios.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

/* install/uninstall
register_activation_hook( __FILE__, 'gstandout_activate' );
register_deactivation_hook( __FILE__, 'gstandout_deactivate' );
register_uninstall_hook( __FILE__, 'gstandout_uninstall' );
*/

/* Define the custom box */

// WP 3.0+
add_action( 'add_meta_boxes', 'gstandout_add_custom_box' );
add_action( 'save_post', 'gstandout_save_postdata' );
add_action( 'wp_head', 'gstandout_meta' );

/* Adds a box to the main column on the Post and Page edit screens */
function gstandout_add_custom_box() {
	add_meta_box(
		'gstandout_sectionid',
		__( 'Google News Publisher META', 'gstandout_textdomain' ),
		'gstandout_inner_custom_box',
		'post'
		);
	add_meta_box(
		'gstandout_sectionid',
		__( 'Google News Publisher META', 'gstandout_textdomain' ),
		'gstandout_inner_custom_box',
		'page'
		);
}

/* Prints the box content */
function gstandout_inner_custom_box( $post ) {
	global $post;

	$meta_url = get_post_meta($post->ID, 'gstandout_url', true);
	$meta_type = get_post_meta($post->ID, 'gstandout_type', true);

	echo '<label for="gstandout_type">';
	_e("Referenced Type", 'gstandout_textdomain' );
	echo '</label>';
	echo '<select name="gstandout_type">';
	if ($meta_type=='none')
	 echo '<option value="none" selected="selected">None</option>';
	else
	 echo '<option value="none">None</option>';
	if ($meta_type=='standout')
	 echo '<option value="standout" selected="selected">Current post as standout</option>';
	else
	 echo '<option value="standout">Current post as standout</option>';
	if ($meta_type=='otherstandout')
	 echo '<option value="otherstandout" selected="selected">Other article as standout</option>';
	else
	 echo '<option value="otherstandout">Other article as standout</option>';
	if ($meta_type=='syndication')
	 echo '<option value="syndication" selected="selected">URL as syndication</option>';
	else
	 echo '<option value="syndication">URL as syndication</option>';
	if ($meta_type=='canonical')
	 echo '<option value="canonical" selected="selected">URL as canonical</option>';
	else
	 echo '<option value="canonical">URL as canonical</option>';
	echo '</select>';
	echo '<br />';
	echo '<label for="gstandout_url">';
	_e("Referenced URL if not current post (include http://)", 'gstandout_textdomain' );
	echo '</label> ';
	echo '<input type="text" id="gstandout_url" name="gstandout_url" value="'.$meta_url.'" size="125" />';
}

function gstandout_save_postdata( $post_id ) {
//	if (isset($_POST['gstandout_url']) and isset($_POST['gstandout_type'])) {
	if (isset($_POST['gstandout_type']) and $_POST['gstandout_type'] != 'None') {
		$gurl = $_POST['gstandout_url'];
		$gtype = $_POST['gstandout_type'];

		update_post_meta($post_id, 'gstandout_url', $gurl);
		update_post_meta($post_id, 'gstandout_type', $gtype);
	} else {
		delete_post_meta($post_id, 'gstandout_type');
		delete_post_meta($post_id, 'gstandout_url');
	}
}

function gstandout_meta() {
	global $post;
	$url = get_post_meta($post->ID, 'gstandout_url', true);
	$type = get_post_meta($post->ID, 'gstandout_type', true);

	if ( $type == 'standout' ) {
		echo '<link rel="standout" href="' . get_permalink($post->ID) . '" />' . "\n";
	} elseif ( $type == 'otherstandout' ) {
		echo '<link rel="standout" href="' .$url. '" />' . "\n";
	} elseif ( $url ) {
		echo '<link rel="'.$type.'" href="'.$url.'"/>'."\n";
		remove_action('wp_head', 'rel_canonical');
	}
}

?>